//+------------------------------------------------------------------+
//|                                                     Momentum.mq4 |
//|                                      Copyright  2011, Serg Deev |
//|                                         http://www.work2it.ru/   |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Serg Deev"
#property link      "http://www.work2it.ru/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
//---- input parameters
extern int MomPeriod=14;
extern int MaPeriod=3;
extern int MaMethod=2; // 0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA;
//---- buffers
double MomBuffer[],mom[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT,1);
   SetIndexBuffer(0,MomBuffer);
   SetIndexBuffer(1,mom);
//---- name for DataWindow and indicator subwindow label
   short_name="MomentumMOD("+MomPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,MomPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=MomPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=MomPeriod;i++) MomBuffer[Bars-i]=0.0;
//----
   i=Bars-MomPeriod-1;
   if(counted_bars>=MomPeriod) i=Bars-counted_bars-1;
   while(i>=0) {
    MomBuffer[i]=Close[i]*100/Close[i+MomPeriod];
    i--;
   }
   for (i=Bars-counted_bars-1; i>=0; i--) {
    mom[i] = iMAOnArray(MomBuffer,0,MaPeriod,0,MaMethod,i);
   }
   return(0);
  }
//+------------------------------------------------------------------+